/*
 * MRun.h
 *
 *  Created on: Apr 1, 2010
 *      Author: dbjorge
 *
 * Copyright 2010 Worcester Polytechnic Institute
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef MRUN_H_
#define MRUN_H_

/*
 *
 */
#include "RolloutMonteCarlo.h"

class MRun: public RolloutMonteCarlo {
public:
	MRun(unsigned int m, bool recalling, double effectiveness);
	virtual ~MRun();

	virtual void iterate();
	virtual action_t currentBestMove();
	virtual void reset();
	virtual std::string toString() const;
private:
	unsigned int mM;
	bool mRecalling;
	bool mPlayForever;
	action_t mNextAction;
	unsigned int mCurrentHistory;
	unsigned int mArmsPlayed;
	action_t mBestArm;
	unsigned int mBestHistory;
};

#endif /* MRUN_H_ */
