/*
 * Minimax.h
 *
 *  Created on: Apr 1, 2010
 *      Author: dbjorge
 *
 * Copyright 2010 Worcester Polytechnic Institute
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef MINIMAX_H_
#define MINIMAX_H_

#include "../search/SearchAlgorithm.h"

/*
 *
 */
class Minimax : public SearchAlgorithm {
public:
	Minimax();
	virtual ~Minimax();

	virtual void iterate();
	virtual action_t currentBestMove();
	virtual void reset();
	virtual std::string toString() const;
protected:
	virtual double evaluate(GameState& state);
private:
	bool mFinished;
	action_t mChosenAction;
};

#endif /* MINIMAX_H_ */
