/*
 * MinimaxUCT.h
 *
 *  Created on: Apr 19, 2010
 *      Author: dbjorge
 *
 * Copyright 2010 Worcester Polytechnic Institute
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef MINIMAXUCT_H_
#define MINIMAXUCT_H_

/*
 *
 */
#include "MinimaxMonteCarlo.h"

class MinimaxUCT: public MinimaxMonteCarlo {
protected:
	double explorationConst;
	double fpuConst;
	virtual double evaluate(GameState& state);
	virtual double evaluateFirst(GameState& parent);
	virtual double explorationBias(GameState& state);
public:
	MinimaxUCT(double effectiveness, double discount, double fpuConst = 10000);
	virtual ~MinimaxUCT();
	virtual std::string toString() const;
};

#endif /* MINIMAXUCT_H_ */
