#!/usr/bin/python

# Usage:
# python scriptname.py results_dir alg num_attrs
from __future__ import with_statement
import sys, string, os, shutil

SEP=','
iteration = 0

if __name__=='__main__':
    #scriptname = sys.argv[0]
    resultDir = sys.argv[1]
    alg = sys.argv[2]
    numAttrs = int(sys.argv[3])

    runDirs = [f for f in os.listdir(resultDir) if os.path.isdir(resultDir+'/'+f)]
    runDirs.sort()
    
    #Iterate over algs, streaming all of the results files into one line by line
    with open(resultDir+'/'+alg+'.dat',"w") as algFile:
        fileNames = [resultDir+'/'+runDir+'/'+alg+'.dat' for runDir in runDirs]
        files = []
        try:
            files = [open(f, "r") for f in fileNames]
            eof = False
            while not eof:
                line = [0]*numAttrs
                for f in files:
                    fLine = f.readline().rstrip()
                    if(fLine == ""):
                        eof = True
                        break
                    fData = [float(d) for d in fLine.split(SEP)]
                    for i in range(numAttrs):
                        line[i] += fData[i]
                if eof:
                    break
                algFile.write(SEP.join([str(datum) for datum in line])+"\n")
        finally:
            for f in files:
                f.close()
                
