#!/bin/bash

source $(dirname $0)/gombaheader.sh

echo ""

echo "----- Copying consolodation scripts to remote server -----"
CONSOLIDATE_SCRIPT_PATH=$CLUSTER_PATH/consolidate_results.py
scp $(dirname $0)/generate_consolidate_subm.py $CLUSTER_FULLHOST:$CLUSTER_PATH/generate_consolidate_subm.py
error_exit "Failed to remote copy consolidate subm generator script"
scp $(dirname $0)/subm_vars.py $CLUSTER_FULLHOST:$CLUSTER_PATH/subm_vars.py
error_exit "Failed to remote copy subm_vars"
scp $(dirname $0)/consolidate_results.py $CLUSTER_FULLHOST:$CONSOLIDATE_SCRIPT_PATH
error_exit "Failed to remote copy consolidation script"
echo "----- Consolidation scripts copied -----"

echo ""

echo "----- Generating consolidation condor submission -----"
cluster_run "python generate_consolidate_subm.py $CLUSTER_PATH/$RESULTS_DIR $CONSOLIDATE_SCRIPT_PATH > consolidate_results.subm"
error_exit "Failed to generate condor submission for result consolidation"
echo "----- Condor subm generated -----"

echo ""

echo "----- Submitting consolidation jobs -----"
cluster_submit "consolidate_results.subm" 10
error_exit "Failed to submit consolidation jobs!" 
echo "----- Consolidation complete -----"

echo ""

echo "----- rsyncing remote results... -----"
scp -C $CLUSTER_FULLHOST:$CLUSTER_PATH/$RESULTS_DIR/*.* ./$RESULTS_DIR/
error_exit "Failed to rsync results to local box!" 
echo "----- results rsync complete -----"

echo ""

echo "----- Results parsed. Generating default plots... -----"
python $(dirname $0)/plot_runner.py $RESULTS_DIR
error_exit "Failed to generate default plots"
echo "----- Default plots generated -----"