args <- commandArgs(TRUE)
results <- args[1]
out <- args[2]
trials <- as.integer(args[3])
iterations <- as.integer(args[4])
xcol <- as.integer(args[5])

movingLength <- 50

algsIndex <- 6

allAlgs <- args[algsIndex:length(args)]
numAlgs <- length(allAlgs)

print(allAlgs)

xlimrange <- c(0,iterations)
ylimrange <- c(0,trials)

print(xlimrange)
print(ylimrange)

png(out)

plot(c(), c(), type="n", xlim=xlimrange, ylim=ylimrange, xlab="Iterations", ylab=paste("Wins (out of ", trials, ")", sep=''))

colors <- rainbow(numAlgs) 
linetype <- c(1:numAlgs) 
plotchar <- seq(18,18+numAlgs,1)

# add lines 
for (i in 1:numAlgs) { 
  alg <- allAlgs[i]
  d <- read.table(paste(results, "/", alg, ".dat", sep=''), sep=",", header=FALSE)
#  points(d$V1, lwd=1.5, lty=linetype[i], col=colors[i], pch=plotchar[i])
  lines(smooth.spline(d[[xcol]], d$V1), lwd=1.5, lty=linetype[i], col=colors[i], pch=plotchar[i])
} 

# add a title and subtitle 
title("Search Algorithm Win Rate")

# add a legend 
legend(iterations*0.7, trials/2, allAlgs, cex=0.8, col=colors,
  		   pch=plotchar, lty=linetype, title="Algorithm")

#Finish plot drawing
dev.off()