args <- commandArgs(TRUE)
results <- args[1]
out <- args[2]
trials <- as.integer(args[3])
iterations <- as.integer(args[4])

diffBound <- trials * .25

movingLength <- 50

algsIndex <- 5

allAlgs <- args[algsIndex:length(args)]
numAlgs <- length(allAlgs)

print(allAlgs)

xrange <- 0:iterations
yrange <- 0:trials
xlimrange <- c(0,iterations)
ylimrange <- c(-diffBound,diffBound)

print(xlimrange)
print(ylimrange)

png(out)

plot(c(), c(), type="n", xlim=xlimrange, ylim=ylimrange, xlab="Iterations", ylab=paste("Average difficulty (* ", trials, ")", sep=''))

colors <- rainbow(numAlgs) 
linetype <- c(1:numAlgs) 
plotchar <- seq(18,18+numAlgs,1)

# add lines 
for (i in 1:numAlgs) { 
  alg <- allAlgs[i]
  d <- read.table(paste(results, "/", alg, ".dat", sep=''), sep=",", header=FALSE)
#  points(d$V1, lwd=1.5, lty=linetype[i], col=colors[i], pch=plotchar[i]) 
  lines(filter(d$V2, rep(1/movingLength, movingLength), sides=1), lwd=1.5, lty=linetype[i], col=colors[i])
} 

# add a title and subtitle 
title("Search Algorithm Guess Difficulty")

# add a legend 
legend(iterations*0.7, diffBound*.95, allAlgs, cex=0.8, col=colors,
  		   lty=linetype, title="Algorithm")

#Finish plot drawing
dev.off()