#!/usr/bin/python

# Usage:
# python scriptname.py results_dir
from __future__ import with_statement
import sys, string, os, shutil

#filename : output_suffix
plotScripts = {
    'plotAllAlgs.R':'wins',
    'plotAllVsDiff.R':'diff'
}

if __name__=='__main__':
    #scriptname = sys.argv[0]
    resultDir = sys.argv[1]

    algs = []
    resultContents = os.listdir(resultDir)
    for path in resultContents:
        dotIndex = path.rfind('.')
        if dotIndex != -1 and path[dotIndex+1:] == 'dat':
            algs += [path[:dotIndex]]
    algs.sort()

    algStr = ' '.join(algs)

    print 'Rendering plots for algorithms:'
    print algStr

    trials = -1

    with open(resultDir+'/'+algs[0]+'.dat') as firstAlgFile:
        iterations = 0
        for line in firstAlgFile:
            iterations += 1

    while trials == -1:
        inp = raw_input('[plot_runner] Number of trails = ')
        try:
            trials = int(inp)
        except:
            print 'Invalid input, try again'

  
    runid = raw_input('[plot_runner] Run identifier string = ')

    for (plotScript, outputSuffix) in plotScripts.items():
        outFile = resultDir+'/'+runid+'-'+outputSuffix+'.png'
        command = 'Rscript --vanilla %s %s %s %d %d %s' % (plotScript, resultDir, outFile, trials, iterations, algStr)

        print '**Rendering '+outFile+' with '+plotScript
        print '**Command: '+command
        
        os.system(command)

    endResultDir = 'resultsets/'+runid
    print '**Moving results to runid-based directory '+endResultDir

    shutil.move(resultDir, endResultDir)
    
