#!/bin/bash

source $(dirname $0)/gombaheader.sh

RESTRICTIONS=$1
if [ "$1" = "" ] ; then
    RESTRICTIONS=$CLUSTER_USER
fi

TIME=$2
if [ "$2" = "" ] ; then
    TIME=$POLL_WAIT_TIME
fi

echo "----- Querying every $TIME seconds... -----"
doneworking=0
while [ $doneworking -eq 0 ]
do
    sleep $TIME
    echo -n "Querying condor at "
    echo -n `date +%H:%M:%S`
    echo -n "..."

    cluster_run "echo -n \"...  \""
    if [ "$?" -ne "0" ] ; then
	echo "WARNING: Could not contact condor server. Ignoring query..."
	continue
    fi

    running=`cluster_run "condor_q -run $RESTRICTIONS | grep -c \"$RESTRICTIONS\""`
    held=`cluster_run "condor_q -hold $RESTRICTIONS | grep -c \"$RESTRICTIONS\""`
    total=`cluster_run "condor_q $RESTRICTIONS | grep -c \"$RESTRICTIONS\""`

    echo "$total jobs ($running running, $held held)"
    if [ "$held" -ne "0" ] ; then
	echo "WARNING: Held jobs detected. Consider condor_release-ing"
    fi

    if [ "$total" -eq "0" ] ; then
	doneworking=1
    fi
done

echo "----- Jobs completed. -----"
echo ""
